(function () {

  'use strict';

  var csInterface = new CSInterface();   
     
//Main UI   

    
function myFunction(){
alert('hi');
}    

  document.getElementById('btnBlurGallery').addEventListener('click', function () {csInterface.evalScript('blurGallery()');}); 
  document.getElementById('btnLightingEffects').addEventListener('click', function () {csInterface.evalScript('lightingEffects()');});     
  document.getElementById('btnSelectAndMask').addEventListener('click', function () {csInterface.evalScript('selectAndMask()');});      
    
  document.getElementById('btnSkipImage').addEventListener('click', function () {
        disableBtns();
        var imagePath=saveFolder+'/'+imageList[imageIndex-1];
        var saveData=[imageList[imageIndex-1],sourceFolder];
        csInterface.evalScript('skipImage("' + saveData + '")'); 
        batchImageOpen=false;
        if(lastImage==true){
            resetBtns();
            showTab1();
            resetGlobalVars();
            csInterface.evalScript('finish("' + sourceFolder + '")');         
        }
      });    

  document.getElementById('btnContinue').addEventListener('click', function () {
        disableBtns();
        var imagePath=saveFolder+'/'+imageList[imageIndex-1];
        var customName=document.getElementById('customFilename').value.replace(/,/g,'ZcommaZ');
        var saveData=[saveFolder,imageList[imageIndex-1],imageList[imageIndex-1],sourceFolder,saveType.value,jpgQuality.value,saveNameOptions.value,customName];
        csInterface.evalScript('saveImage("' + saveData + '")', function(retVal){
        batchImageOpen=false; 
        if(lastImage==true){
            resetBtns();
            showTab1();
            resetGlobalVars();
            csInterface.evalScript('finish("' + sourceFolder + '")');         
        }                                                                                                                                                   
        });         
      });      

  document.getElementById('btnStopBatch').addEventListener('click', function (){resetBtns(); showTab1(); resetGlobalVars();});
    
//Batch Settings UI   
    
  document.getElementById('btnSourceFolder').addEventListener('click', function () {
        
      
        csInterface.evalScript('getFolder()', function(retVal) {
        var folderData=retVal.split(',');  
        if(folderData[1]==undefined){document.getElementById("sourceFolderName").innerHTML = "No Folder Selected";}
        else{
            sourceFolder=folderData[0];
            folderData[1]=folderData[1].replace(/%20/g,' ');
            folderData[1]=folderData[1].replace(/ZcommaZ/g,',');

            if(folderData[1].length<20){folderData[1]='.../'+folderData[1];}
            else{folderData[1]='...'+folderData[1].substring(folderData[1].length-18,folderData[1].length);}
            document.getElementById("sourceFolderName").innerHTML = folderData[1];
                       
        }
            
            if(document.getElementById('checkBoxSaveInSource').checked==true){
            saveFolder=sourceFolder;
            document.getElementById("saveFolderName").innerHTML = document.getElementById("sourceFolderName").innerHTML; 
            }            
            
        });

      
  }); 
    
    
  document.getElementById('btnSaveFolder').addEventListener('click', function () {
        csInterface.evalScript('getFolder()', function(retVal) {
        var folderData=retVal.split(',');  
        if(folderData[1]==undefined){document.getElementById("saveFolderName").innerHTML = "No Folder Selected";}
        else{
            folderData[1]=folderData[1].replace(/%20/g,' ');
            folderData[1]=folderData[1].replace(/ZcommaZ/g,',');
            saveFolder=folderData[1];
            if(folderData[1].length<20){folderData[1]='.../'+folderData[1];}
            else{folderData[1]='...'+folderData[1].substring(folderData[1].length-18,folderData[1].length);}
            document.getElementById("saveFolderName").innerHTML = folderData[1];
            saveFolder=folderData[0];
            //saveFolder=saveFolder.replace(/ZcommaZ/g,',');
        }
      });
      
      
  });     
    
   document.getElementById('checkBoxSaveInSource').addEventListener('click', function () {
     
        if(document.getElementById('checkBoxSaveInSource').checked==true){
        document.getElementById("btnSaveFolder").disabled=true;
        saveFolder=sourceFolder;
        document.getElementById("saveFolderName").innerHTML = document.getElementById("sourceFolderName").innerHTML; 
        }
        else{document.getElementById("btnSaveFolder").disabled=false;}
  });   
    
  document.getElementById('btnStartBatch').addEventListener('click', function () {      
        disableBtns();
        startBatch();
      });             
 

    
function disableBtns(){ 
    document.getElementById("btnSkipImage").disabled=true;
    document.getElementById("btnContinue").disabled=true;
    document.getElementById("btnStopBatch").disabled=true;     
    document.getElementById("processing").style.display= "block";
} 
    
function enableBtns(){
    document.getElementById("processing").style.display= "none";
    document.getElementById("btnSkipImage").disabled=false;
    document.getElementById("btnContinue").disabled=false;  
    document.getElementById("btnStopBatch").disabled=false;    
} 
    
function startBatch(){
var imageListComplete=false;
var saveFolderStatusComplete=false;
var saveFolderWriteOK='false';
var sourceData=[sourceFolder,sourceType.value];
  
    
            csInterface.evalScript('getImageList("' + sourceData + '")', function(retVal){
            imageList=[];    
            imageList=retVal.split(',');
            for(var i=0;i<imageList.lenght;i++){
                //imageList[i]=imageList[i].replace(/ZcommaZ/g,',');
                imageList[i]=imageList[i].replace(/%20/g,' '); 
            }
            imageListComplete=true;    
            });
    
            csInterface.evalScript('getWriteStatus("' + saveFolder + '")', function(retVal){saveFolderWriteOK=retVal; saveFolderStatusComplete=true;});

            var waitForFolderInfo=setInterval(function(){           
            if(imageListComplete==true&&saveFolderStatusComplete==true){
                clearInterval(waitForFolderInfo);
                if (imageList=='cancel'){enableBtns();}
                else if(imageList.length==0){csInterface.evalScript('noImagesMessage()'); enableBtns();}
                else if(imageList==''){csInterface.evalScript('noImagesMessage()'); enableBtns();}
                else if(saveFolderWriteOK!='true'){csInterface.evalScript('noWriteAccessMessage()'); enableBtns();}
                else{
                    document.getElementById("tab1").style.display= "none";      
                    document.getElementById("tab2").style.display= "block";
                    document.getElementById("btnStopBatch").style.display= "block";      
                    document.getElementById("btnSkipImage").style.display= "block";
                    document.getElementById("btnContinue").style.display= "block";
                    document.getElementById("batchProgress").style.display= "block"; 
                    startBatch2();
                } 
            } 
            },50);    


    
    
}

  
    
function startBatch2(){ 
imageOpenCount=0;
imageIndex=0;
batchStopCommand=false;
batchImageOpen=false;
imageOpenOK=true;

    var batchCount=setInterval(function(){ 

        csInterface.evalScript('getImageCount()', function(retVal){imageOpenCount=Number(retVal);});
        
        if(imageIndex<imageList.length&&batchImageOpen==false&&batchStopCommand==false){
        batchImageOpen=true;        
        var imagePath=sourceFolder+'/'+imageList[imageIndex];
        imageIndex++;
        document.getElementById("batchProgress").innerHTML = "Image "+imageIndex+" of "+imageList.length;
        csInterface.evalScript('openImage("' + imagePath + '")', function(retVal){imageOpenOK=retVal;imageOpenCompleted=true;});
            
            var waitForImage=setInterval(function() {           
            if(imageOpenCompleted==true){
                enableBtns();
                imageOpenCompleted=true;   
                clearInterval(waitForImage);         
            } 
            },200);
            
        }
        
        if(imageOpenOK=='false'){imageOpenOK=true; skipNoOpen();}
        if(imageIndex>=imageList.length){lastImage=true; clearInterval(batchCount);}
        else if(batchStopCommand==true){clearInterval(batchCount);}
        
         //alert('hi');                 
    }, 300);  
    
}

function skipNoOpen(){
        disableBtns();
        var imagePath=saveFolder+'/'+imageList[imageIndex-1];
        var saveData=[imageList[imageIndex-1],sourceFolder];
        csInterface.evalScript('skipImage("' + saveData + '")'); 
        batchImageOpen=false;
        if(lastImage==true){
            resetBtns();
            showTab1();
            resetGlobalVars();
            csInterface.evalScript('finish("' + sourceFolder + '")');         
        }
      }    
    
function resetGlobalVars(){   
//sourceFolder=' ';
//saveFolder=' ';
//imageList=[];
batchImageOpen=false;
imageOpenCount=0;
imageIndex=0;
imageOpenCompleted=false;
lastImage=false;
batchStopCommand=true;
}

function resetBtns(){
enableBtns();    
document.getElementById("btnSkipImage").disabled=true;
document.getElementById("btnContinue").disabled=true;   
document.getElementById("batchProgress").innerHTML=" ";    
document.getElementById("batchProgress").style.display= "none";    
} 
    
function showTab1(){
 //alert('heya');   
document.getElementById("tab2").style.display= "none";      
document.getElementById("tab1").style.display= "block";    
    
}    
    
    

}());

